//+++======================================================================+++
//+++                 Heiken Ashi 2xCCI+MA Swing MTF TT                    +++
//+++======================================================================+++
#property copyright   "  Tankk,  21  September  2016,  http://forexsystems.ru/" 
#property link        "http://forexsystemsru.com/indikatory-foreks-f41/" 
#property description "Swing Trading with Heiken Ashi and Stochastics ++ Hugh Briss == http://www.forexfactory.com/showthread.php?t=340556&page=138  http://www.forexfactory.com/showthread.php?t=479232" 
#property description "********************************************************************************"
#property description "Heiken Ashi       .     ,      ,         ."
#property description " MTF, 2 :  CCI + Moving Average."
#property version "3.0"
//#property strict
#property indicator_chart_window
#property indicator_buffers 7

#property indicator_color1  Red   //Lime       // Shadow of bear candlestick
#property indicator_color2  White   //Red      // Shadow of bull candlestick
#property indicator_color3  Red   //Lime       // Bear candlestick body
#property indicator_color4  White   //Red      // Bull candlestick body
#property indicator_color5  Magenta   //Lime
#property indicator_color6  DodgerBlue   //Red
#property indicator_color7  Gold   //LimeGreen   //Red

#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  2

//+++======================================================================+++
//+++                 Custom indicator input parameters                    +++
//+++======================================================================+++

extern bool               ShowWicks  =  true;
extern ENUM_TIMEFRAMES    TimeFrame  =  PERIOD_CURRENT;     //    
extern string filterCCI = "-----------------------------------------------------------------";
extern bool         CCIFilterEnable  =  true;
extern int                 TurboCCI  =  6,               
                            SlowCCI  =  15;
extern ENUM_APPLIED_PRICE  CCIPrice  =  PRICE_TYPICAL;
extern double           CCIHotLevel  =  100.0;
extern string filterMA = "-----------------------------------------------------------------";
extern bool          MAFilterEnable  =  true;
extern int                 MAPeriod  =  60;
extern ENUM_MA_METHOD      MAMethod  =  MODE_LWMA;
extern ENUM_APPLIED_PRICE   MAPrice  =  PRICE_WEIGHTED;
extern bool            ShowMAFilter  =  true;
extern string arrows = "-----------------------------------------------------------------";
extern int                SIGNALBAR  =  1;
extern double              ArrowGap  =  2.0;   //  High/Low  (Koef for ATR)  
extern int                 ArrCodDN  =  234,   //181,  233,   //225
                           ArrCodUP  =  233;   //147,  116, 117, 234,   //226
extern string alerts =  "-----------------------------------------------------------------";
extern bool           AlertsMessage  =  true,   //false,    
                        AlertsSound  =  true,   //false,
                        AlertsEmail  =  false,
                       AlertsMobile  =  false;
extern string               SoundDN  =  "analyze sell.wav",   //"news.wav",   //"stops.wav"   //"alert2.wav"   //"expert.wav"
                            SoundUP  =  "analyze buy.wav";

//+++======================================================================+++
//+++                     Custom indicator buffers                         +++
//+++======================================================================+++
double ExtLowHighBuffer[], ExtHighLowBuffer[];
double ExtOpenBuffer[], ExtCloseBuffer[];
double signalDN[], signalUP[], MAFilter[];
double haBufOpen[], haBufClose[];
double haBufLow[], haBufHigh[];   int TimeBar=0; 
//+++======================================================================+++
//+++              Custom indicator initialization function                +++
//+++======================================================================+++

int init() 
{
   IndicatorBuffers(11);   IndicatorDigits(Digits);
   //---
   SetIndexBuffer(0,ExtLowHighBuffer);
   SetIndexBuffer(1,ExtHighLowBuffer);
   SetIndexBuffer(2,ExtOpenBuffer);
   SetIndexBuffer(3,ExtCloseBuffer);
   SetIndexBuffer(4,signalDN);     
   SetIndexBuffer(5,signalUP); 
   SetIndexBuffer(6,MAFilter); 
   //---
   SetIndexBuffer(7,haBufOpen);
   SetIndexBuffer(8,haBufClose);
   SetIndexBuffer(9,haBufLow);
   SetIndexBuffer(10,haBufHigh);
   //---
   int HAW=DRAW_NONE;   if (ShowWicks) HAW=DRAW_HISTOGRAM; 
   SetIndexStyle(0,HAW);
   SetIndexStyle(1,HAW);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_ARROW);   SetIndexArrow(4,ArrCodDN);
   SetIndexStyle(5,DRAW_ARROW);   SetIndexArrow(5,ArrCodUP);
   int MAF=DRAW_NONE;   if (ShowMAFilter) MAF=DRAW_LINE; 
   SetIndexStyle(6,MAF);
   //---
   SetIndexLabel(0,NULL);   SetIndexLabel(1,NULL);
   SetIndexLabel(2,"HA DN");   SetIndexLabel(3,"HA UP");
   SetIndexLabel(4,"Sell Signal");   SetIndexLabel(5,"Buy Signal");
   SetIndexLabel(6,"MAFilter ["+MAPeriod+"]");
   //---
  	SetIndexEmptyValue(0,0.0);   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);   SetIndexEmptyValue(3,0.0); 
   SetIndexEmptyValue(4,0.0);   SetIndexEmptyValue(5,0.0); 
   SetIndexEmptyValue(6,0.0); 
   
   IndicatorShortName("HA 2xCCI+MA Swing MTF TT");
   
//---//---//---//
return(0);   
}
//+++======================================================================+++
//+++              Custom indicator deinitialization function              +++
//+++======================================================================+++
int deinit() { return(0); }
//+++======================================================================+++
//+++                 Custom indicator iteration function                  +++
//+++======================================================================+++

int start() 
{
   if (Bars <= 10) return(0);
   int ExtCountedBars=IndicatorCounted();
   if (ExtCountedBars<0) return(-1);
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   //---
   double haOpen, haHigh, haLow, haClose;
   double preTCCI, curTCCI, preSCCI, curClos;
//+++======================================================================+++
   for (int i=pos; i>=0; i--)  //for (i=0, y=0; i<limit; i++)   //while (pos>=0) { pos-- }
    {  
     int y=iBarShift(NULL,TimeFrame,Time[i],false);   
     if (TimeFrame < Period()) TimeFrame=PERIOD_CURRENT;   		
     //---
     haOpen  = (haBufOpen[i+1] + haBufClose[i+1]) /2;
     haClose = (iOpen(NULL,TimeFrame,y) + iHigh(NULL,TimeFrame,y) + iLow(NULL,TimeFrame,y) + iClose(NULL,TimeFrame,y)) /4;      
     haHigh  = MathMax(iHigh(NULL,TimeFrame,y), MathMax(haOpen, haClose));
     haLow   = MathMin(iLow(NULL,TimeFrame,y), MathMin(haOpen, haClose));
     //---
     haBufOpen[i] = haOpen;
     haBufClose[i]= haClose;
     haBufHigh[i] = haHigh;
     haBufLow[i]  = haLow;
     //+++======================================================================+++
        if (haOpen < haClose) {
           ExtLowHighBuffer[i]=haLow;
           ExtHighLowBuffer[i]=haHigh; } 
        else {
           ExtLowHighBuffer[i]=haHigh;
           ExtHighLowBuffer[i]=haLow;  }
     //---
     ExtOpenBuffer[i]=haOpen;
     ExtCloseBuffer[i]=haClose;
//+++======================================================================+++
//+++                 Heiken Ashi 2xCCI+MA Swing MTF TT                    +++
//+++======================================================================+++
     if (MAPeriod<1) MAFilter[i]=EMPTY_VALUE;
     MAFilter[i]=iMA(NULL,TimeFrame,MAPeriod,0,MAMethod,MAPrice,y);
     //+++======================================================================+++
     //double Range=0;   double AvgRange=0;
     //for (int r=pos; r<=pos+9; r++ )  AvgRange=AvgRange+MathAbs(High[r]-Low[r]);   Range=AvgRange;    
     double Range=ArrowGap*iATR(NULL,TimeFrame,20,y)/4;
     signalDN[i]=0;   signalUP[i]=0; 
     //+++======================================================================+++
     if (CCIFilterEnable) {       
     preTCCI=iCCI(NULL,TimeFrame,TurboCCI,CCIPrice,y+1+SIGNALBAR);
     curTCCI=iCCI(NULL,TimeFrame,TurboCCI,CCIPrice,y+SIGNALBAR);
     preSCCI=iCCI(NULL,TimeFrame,SlowCCI,CCIPrice,y+1+SIGNALBAR);
     curClos=iClose(NULL,TimeFrame,y+SIGNALBAR); }
     //---
     if (!CCIFilterEnable) {       
     preTCCI=iClose(NULL,TimeFrame,y+1+SIGNALBAR);
     curTCCI=iClose(NULL,TimeFrame,y+SIGNALBAR); }
     //---
     if (CCIFilterEnable && MAFilterEnable) {
     if (curTCCI > CCIHotLevel && preTCCI < CCIHotLevel && preSCCI < CCIHotLevel && haOpen < haClose && curClos > MAFilter[i+SIGNALBAR])  signalUP[i]=iLow(NULL,TimeFrame,y)  -Range;
     if (curTCCI <-CCIHotLevel && preTCCI >-CCIHotLevel && preSCCI >-CCIHotLevel && haOpen > haClose && curClos < MAFilter[i+SIGNALBAR])  signalDN[i]=iHigh(NULL,TimeFrame,y) +Range; }
     //---
     if (CCIFilterEnable && !MAFilterEnable) {
     if (curTCCI < CCIHotLevel && preTCCI > CCIHotLevel && preSCCI > CCIHotLevel && haOpen > haClose)  signalDN[i]=iHigh(NULL,TimeFrame,y) +Range;
     if (curTCCI >-CCIHotLevel && preTCCI <-CCIHotLevel && preSCCI <-CCIHotLevel && haOpen < haClose)  signalUP[i]=iLow(NULL,TimeFrame,y)  -Range; }
     //---
     if (!CCIFilterEnable && MAFilterEnable) {
     if (haOpen < haClose && preTCCI < MAFilter[i+1+SIGNALBAR] && curTCCI > MAFilter[i+SIGNALBAR])  signalUP[i]=iLow(NULL,TimeFrame,y)  -Range;
     if (haOpen > haClose && preTCCI > MAFilter[i+1+SIGNALBAR] && curTCCI < MAFilter[i+SIGNALBAR])  signalDN[i]=iHigh(NULL,TimeFrame,y) +Range; }
//+++======================================================================+++
//+++                 Heiken Ashi 2xCCI+MA Swing MTF TT                    +++
//+++======================================================================+++
     if (AlertsMessage || AlertsEmail || AlertsMobile || AlertsSound) 
      {
       string messageHA;
       //---
       if (TimeBar!=Time[0] && signalDN[0]!=0) 
        {
         messageHA =("HA 2xCCI+MA Swing MTF TT - "+Symbol()+", TF ["+IntegerToString(Period())+"] =  Swing DN  ==  SELL");   //BearsBulls Alerts MTF TT //SSL Channel TT
         if (AlertsMessage) Alert(messageHA);
         if (AlertsEmail)   SendMail(Symbol(),messageHA);
         if (AlertsMobile)  SendNotification(messageHA);
         if (AlertsSound)   PlaySound(SoundDN);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        } 
       //---
       else if (TimeBar!=Time[0] && signalUP[0]!=0) 
        { 
         messageHA =("HA 2xCCI+MA Swing MTF TT - "+Symbol()+", TF ["+IntegerToString(Period())+"] =  Swing UP  ==  BUY");   //BearsBulls Alerts MTF TT //SSL Channel TT
         if (AlertsMessage) Alert(messageHA);
         if (AlertsEmail)   SendMail(Symbol(),messageHA);
         if (AlertsMobile)  SendNotification(messageHA);
         if (AlertsSound)   PlaySound(SoundUP);   //"stops.wav"   //"news.wav"
         TimeBar=Time[0];
         //return(0);
        }
      }
//+++======================================================================+++
//---//---//--- * * for (int i=pos; i>=0; i--)
    }
//---//---//---//
return(0);  //---//,  , ..... :))
}
//+++======================================================================+++
//+++                 Heiken Ashi 2xCCI+MA Swing MTF TT                    +++
//+++======================================================================+++   